class Array
  def middle
    if self.length % 2 == 0 then
      return Array.new << self[self.length / 2] << self[(self.length/2) + 1]
    else return self[self.length / 2] end
  end

  def each_bigger_than val, &block
    self.each do |x| block.yield x if x > val end
  end
  
  def each_smaller_than val, &block
    self.each do |x| block.yield x if x < val end
  end
  
  def each_if_in range, &block
    self.each do |x| block.yield x if range.include? x end 
  end
  
  def each_if_not_in range, &block
    self.each do |x| block.yield x if not range.include? x end
  end
  
  def each_which_is_a type, &block
    self.each do |x| block.yield x if x.is_a? type end
  end

  def each_which_is num, &block
    self.each do |x| block.yield x if x == num end
  end

  def each_without *withouts, &block
    self.each do |x| block.yield x if not withouts.include? x end
  end

  def each_without_indexes *indexes, &block
    self.each_with_index do |x,i| block.yield(x,i) if not indexes.include? i end
  end

  def each_with_prev_next &block
    [nil, *self, nil].each_cons(3, &block)
  end

  def average
    return self.inject{|sum, element| sum + element }.to_f / self.length
  end

  def find_each_index num
    indexes = Array.new
    self.each_with_index do |e,i| indexes.push i if e == num end
    return indexes
  end

  def find_each_which_is_a type
    ret = Array.new
    self.each do |v| ret.push v if v.is_a? type end
    return ret
  end

  def includes_elements? array
    ret = Array.new
    array.each { |ae| ret << self.include?( ae ) }
    return ret
  end

  def includes_all_elements? array
    array.each { |ae| return false if not self.include?( ae )}
    return true
  end

  def includes_elements_where? array
    ret = Array.new
    array.each_with_index { |ae, i| ret << i if self.include?( ae ) }
    return ret
  end

  def move_range range, to
    array = self.clone

    range.count.times do 
      if to > range.last then array.insert(to, array.delete_at( range.first ) )
      else array.insert(to, array.delete_at( range.last ) ) end
    end
    return array
  end
end
