class String
  
  def capitalize_words all = true
    return self.split.map { |word|
      if all then new = word.capitalize
      else 
        self.words_excluded_from_capitalize.include? word.downcase ? new = word.capitalize : new = word
      end
      new
    }.join ' ' 
  end
  
  def words_excluded_from_capitalize 
    [
      'of','a','the','and','an','or','nor','but','if','then','else','when','up',
      'at','from','by','on','off','for','in','out','over','to', 'while','unless'
    ]
  end

  def ord_complete
    # why? Because I can do it!
    i = 0
    self.each_byte do |b| i += b end
    return (i / self.length)
  end

  alias :average :ord_complete

  def could_be?
    # 
    # returns what class the given string COULD be
    # e.g. if your String is "1.2322" it could be a Float... this method
    # tries to find that out
    #
    
    return FalseClass if self == "false"
    return TrueClass if self == "true"
    
    try = self.clone
    [:to_f, :to_i].each do |s| 
      begin
        newobj = try.__send__(s)
        if newobj.to_s == try then return newobj.class end
      rescue Exception
      end
    end

    require 'json'
    begin 
      newobj = JSON.load self
      if newobj.to_s == self then return newobj.class end
    rescue Exception
    end
    
    return String
  end
end
